## R-2.1.0.tar.gz

=== DESCRIPTION ===
Package: cluster
Version: 1.9.8
Date: 2005-04-04
Priority: recommended
Author: S original by Peter Rousseeuw <rousse@uia.ua.ac.be>, Anja Struyf
	<Anja.Struyf@uia.ua.ac.be> and Mia Hubert <Mia.Hubert@uia.ua.ac.be>.
  R port by Kurt Hornik <Kurt.Hornik@R-project.org> and Martin Maechler
  who has added several extensions.
Maintainer: Martin Maechler <maechler@stat.math.ethz.ch>
Title: Functions for clustering (by Rousseeuw et al.)
Description: Functions for cluster analysis, originally from
  Peter Rousseeuw, Anja Struyf and Mia Hubert.
Depends: R (>= 1.9), stats, graphics, utils
LazyLoad: yes
LazyData: yes
License: GPL version 2 or later
Packaged: Mon Apr  4 19:03:47 2005; maechler

=== src/gnuwin32/Makefile ===
include MkRules
include ../../share/make/vars.mk

all:
	@$(MAKE) --no-print-directory Rpwd.exe
	@$(MAKE) --no-print-directory rbuild
	@$(MAKE) --no-print-directory rpackage
	@$(MAKE) --no-print-directory htmldocs
	@$(MAKE) --no-print-directory  -C ../../po -f Makefile.win

## must be absolute and space-free paths
ifneq ($(strip $(BUILD)),CROSS)
RHOME = $(shell ./Rpwd.exe ../..)
PKGD = $(shell ./Rpwd.exe "$(PKGDIR)")
R_EXE = $(RHOME)/bin/rterm.exe
else
RHOME = $(shell perl pwd.pl ../..)
PKGD = $(shell perl pwd.pl $(PKGDIR))
endif

REXE = $(R_EXE) --vanilla --slave

RPREFIX = $(shell perl fixed/rwver.pl ../../VERSION)

FULLVERSION=`cat ../../VERSION`

DATE = $(shell date +%F)

RLIB = $(RHOME)/library
PKGDIR = $(RHOME)/src/library

OPTFLAGS=-O2 -Wall -pedantic
## use FOPTFLAGS where complex*16 is used.
FOPTFLAGS=-O2 -Wall
ifdef DEBUG
 OPTFLAGS+=-g
 FOPTFLAGS+=-g
 DLLFLAGS=
else
 DLLFLAGS=-s
endif
OPTFLAGS_M=$(OPTFLAGS)

ifneq ($(strip $(BUILD)),CROSS)
R-DLLFLAGS = -mwindows
else
R-DLLFLAGS = -mwindows
endif

## we may not need msvcp60, but no harm to include it.
R-DLLLIBS =-L. $(FLIBS) -lRblas -lcomctl32 -lversion -lmsvcp60 $(LIBEXTRAS)
dllversion-RESFLAGS =--include-dir ../include
SOURCES = \
  console.c dataentry.c dynload.c edit.c editor.c extra.c \
  opt.c pager.c preferences.c psignal.c rhome.c rui.c run.c shext.c \
  sys-win32.c system.c
OBJS = $(SOURCES:.c=.o) e_pow.o
MAINLIBS = ../main/libmain.a ../appl/libappl.a ../nmath/libnmath.a
EXTRALIBS = graphapp/ga.a getline/gl.a ../extra/xdr/libxdr.a \
   ../extra/zlib/libz.a ../extra/pcre/libpcre.a ../extra/bzip2/libbz2.a \
   ../extra/intl/libintl.a

R_PKGS0 = $(filter-out base tools, $(R_PKGS_BASE))
PKGCLEAN = $(foreach i,$(R_PKGS_BASE),pkgclean-$i)

# flags to ensure that Doug Lea's malloc is used:
ifdef LEA_MALLOC
extra-CFLAGS+=-DLEA_MALLOC
OBJS-EXTRA=malloc.o
OPTFLAGS_M+=-DLEA_MALLOC
endif

.PHONY:  clean veryclean  rlibs fixfiles front-ends rmodules


CFLAGS = $(OPTFLAGS) -I../include -I. -DHAVE_CONFIG_H -DR_DLL_BUILD
FFLAGS = $(FOPTFLAGS)

Rpwd.exe: front-ends/Rpwd.exe
	$(CP) $< $@

front-ends/Rpwd.exe:
	$(MAKE) --no-print-directory -C front-ends Rpwd

## watch out: R.dll and Rblas.dll depend on each other.
rbuild:
	@$(MAKE) --no-print-directory fixfiles
	@$(MAKE) --no-print-directory -C ../include -f Makefile.win
	@$(MAKE) --no-print-directory -C ../scripts -f Makefile.win
	@$(MAKE) --no-print-directory libRblas.a
	@$(MAKE) --no-print-directory ../../bin/R.dll
	@$(MAKE) --no-print-directory libR.a
	@$(MAKE) --no-print-directory ../../bin/Rblas.dll CHTML
	@$(MAKE) --no-print-directory front-ends COPYRIGHTS rmodules Rcode

## used to build skeletal versions of packages, enough to run
## package tools to install them properly
INITPACKAGES = base tools
Rcode: fixed/fixdesc
	@$(ECHO) "  making bootstrap versions of packages ..."
	@for pkg in $(INITPACKAGES); do \
	  if ! test -f $(RHOME)/library/$${pkg}/DESCRIPTION ; then \
	  $(ECHO) "  --" $$pkg; \
	  $(MAKE) --no-print-directory -C $(PKGDIR)/$${pkg} PKG=$${pkg} \
	    RHOME=$(RHOME) -f $(RHOME)/src/gnuwin32/MakePkg BUILD=$(BUILD) Rcode  || exit 1; \
	  fi; \
	done
	@$(ECHO) "  ... done"

# methods-LAZY is done directly
graphics-LAZY=true
grDevices-LAZY=true
grid-LAZY=true
splines-LAZY=true
stats-LAZY=true
tcltk-LAZY=true
utils-LAZY=true
datasets-LAZYDATA=true

rpackage: ../../library/R.css rpackageindices
	@R_START_PACKAGES=NULL $(MAKE) --no-print-directory pkg-base
ifneq ($(strip $(BUILD)),CROSS)
	@if ! test -f ../../library/base/R/base.rdb ; then \
	  echo "preparing package base for lazy loading" ; \
	  (echo ".libPaths('../../library')"; \
	    cat ../library/base/makebasedb.R) | \
	    R_DEFAULT_PACKAGES=NULL LC_COLLATE=C $(REXE) > /dev/null; \
          cp ../library/base/baseloader.R ../../library/base/R/base; \
	fi
endif
	@R_START_PACKAGES=NULL $(MAKE) --no-print-directory pkg-tools
	@if ! test -f ../../library/tools/R/tools.rdb ; then \
	  echo "preparing package tools for lazy loading" ; \
	  (cat ../library/tools/R/makeLazyLoad.R; \
	    echo "makeLazyLoading(\"tools\", lib.loc=\"$(RLIB)\")") | \
	    R_DEFAULT_PACKAGES=NULL LC_COLLATE=C $(R_EXE) --vanilla --slave > /dev/null ; \
	fi
	@$(ECHO)
	@for pkg in $(R_PKGS0); do \
	  R_START_PACKAGES=NULL $(MAKE) --no-print-directory pkg-$${pkg} || exit 1; \
	done
	@$(CP) ../library/datasets/data/morley.tab ../../library/datasets/data

rpackageindices:
ifeq ($(strip $(HELP)),YES)
	@$(ECHO)
	@$(ECHO) -n "writing help indices for package:"
	@for pkg in $(R_PKGS_BASE); do \
	  $(ECHO) -n " $${pkg}" ; \
	  $(MAKE) --no-print-directory  -C ./help -s RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) DPKG=$(RLIB)/$${pkg} index-$${pkg} || exit 1; \
	done
	@$(ECHO)
endif


rlibs:
	$(MAKE) --no-print-directory -C ../extra/intl -f Makefile.win
	$(MAKE) --no-print-directory -C ../appl  OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) --no-print-directory -C ../nmath OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) --no-print-directory -C ../main  OPTFLAGS='$(OPTFLAGS_M)' -f Makefile.win
	$(MAKE) --no-print-directory -C ./graphapp
	$(MAKE) --no-print-directory -C ./getline
	@for ex in pcre bzip2 zlib xdr; do \
	  $(MAKE) --no-print-directory -C ../extra/$${ex} -f Makefile.win || exit 1; \
	done

rmodules:
	$(MAKE) --no-print-directory -C ../modules \
	  OPTFLAGS='$(OPTFLAGS)' FOPTFLAGS='$(FOPTFLAGS)' -f Makefile.win
	$(CP) unicode/iconv.dll ../../modules/

COPYRIGHTS: $(RHOME)/COPYRIGHTS COPYRIGHTS.win
	cat $^ > $@


fixfiles: docfiles
	@$(MKDIR) -p ../../bin
	@$(MAKE) --no-print-directory -C ./fixed BUILD=$(BUILD)

fixed/fixdesc:
	@sh fixed/GETDESC $(R_PKGS_BASE)

dllversion.o: ../include/Rversion.h

R.dll: R.a $(OBJS-EXTRA) $(MAINLIBS) $(EXTRALIBS) dllversion.o

Rdll: makeMakedeps libRblas.a ../../bin/R.dll

../../bin/R.dll: FORCE
	@$(MAKE) --no-print-directory fixfiles
	@$(MAKE) --no-print-directory -C ../include -f Makefile.win
	@$(MAKE) --no-print-directory rlibs
	@$(MAKE) --no-print-directory makeMakedeps
	@$(MAKE) --no-print-directory R.dll
	@$(MKDIR) -p ../../bin
	$(CP) R.dll ../../bin/
	@$(MKDIR) -p ./../modules/
ifdef USE_UNICOWS
	$(CP) unicode/opencow.dll ../../bin/
endif

FORCE:

front-ends: libR.a
	$(MAKE) --no-print-directory -C front-ends

R.a: $(OBJS)
	@$(ECHO) -------- Building $@ --------
	@$(RM) R.a
	$(AR) cr R.a $^
	$(RANLIB) R.a


# R.dll exports all global symbols BUT import library (libR.a)
# only (all functions) + (global vars listed in exported-vars))

libR.a:  R.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll --def R.exp --output-lib libR.a

R.exp: R.exp1
	@(diff R.exp R.exp1 > /dev/null 2>&1) || $(CP) R.exp1 R.exp

R.exp1: R.a $(MAINLIBS) $(EXTRALIBS) exported-vars
	@$(ECHO) EXPORTS > $@
	@$(NM) R.a $(MAINLIBS) $(EXTRALIBS) > RDefs
	@$(SED) -n '/^........ [T] _/s/^........ [T] _/ /p' RDefs >> $@
	@$(CAT) exported-vars >> $@
	@$(RM) RDefs

../../library/R.css: ../../doc/html/R.css
	$(CP) $< $@

../extra/zlib/libz.a:
	$(MAKE) --no-print-directory -C ../extra/zlib -f Makefile.win

../extra/pcre/libpcre.a:
	$(MAKE) --no-print-directory -C ../extra/pcre -f Makefile.win

../extra/bzip2/libbz2.a:
	$(MAKE) --no-print-directory -C ../extra/bzip2  -f Makefile.win libbz2.a

htmldocs:
	@$(ECHO)
	@$(ECHO) "------ Making HTML documentation ------"
	@$(MAKE) --no-print-directory -C ../../doc/manual -f Makefile.win html BUILD=$(BUILD)


#                          ===== BLAS ======

Rblas: ../../bin/Rblas.dll

Rblas-clean:
	$(RM) ../../bin/Rblas.dll blas00.o blas00.d blas.o cmplxblas.o \
	  zgemm.o blasGoto.o libgoto.a

Rblas-DLLLIBS=-L. $(LIBUNICOWS) -lR

libRblas.a:  Rblas.def
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname Rblas.dll \
	  --def Rblas.def --output-lib libRblas.a

## suppress lots of warnings: this is a dummy
blas00.o: blas00.c
	$(CC) -O2  -c $< -o $@
blas.o: ../appl/blas.f
	$(F77) $(FFLAGS) -c $< -o $@
zgemm.o: ../appl/zgemm.f
	$(F77) $(FOPTFLAGS) -c $< -o $@
cmplxblas.o: ../modules/lapack/cmplxblas.f
	$(F77) $(FOPTFLAGS) -c $< -o $@

ifeq ($(strip $(USE_GOTO)),YES)
libgoto.a:  libgoto.def
	$(DLLTOOL) $(DLLTOOLFLAGS) --dllname $(GOTO_DLL) --def $< --output-lib $@
../../bin/Rblas.dll: blas00.o blasGoto.o cmplxblas.o zgemm.o dllversion.o libgoto.a
	@$(ECHO) -------- Building $@ --------
	$(DLL) -shared $(DLLFLAGS) -o $@ $^ Rblas.def -L. $(LIBUNICOWS) -lR -lg2c -lgoto
else
ifeq ($(strip $(USE_ATLAS)),YES)
../../bin/Rblas.dll: blas00.o dllversion.o
	@$(ECHO) -------- Building $@ --------
	$(DLL) -shared $(DLLFLAGS) -o $@ $^ Rblas.def -L $(ATLAS_PATH) \
	   -L. $(LIBUNICOWS) -lR -lg2c -lf77blas -latlas
else
../../bin/Rblas.dll: blas.o cmplxblas.o zgemm.o dllversion.o
	@$(ECHO) -------- Building $@ --------
	$(DLL) -shared $(DLLFLAGS) -o $@ Rblas.def $^ -L. $(LIBUNICOWS) -lR
endif
endif


#                          ===== Packages ======

CHTML:
ifeq ($(strip $(HELP)),YES)
ifeq ($(strip $(WINHELP)),CHM)
	$(MAKE) --no-print-directory -C ./help -f MkChmDll
endif
endif

base-HELP = ziponly
datasets-HELP = ziponly
graphics-HELP = ziponly
grDevices-HELP = ziponly
grid-HELP = ziponly
methods-HELP = ziponly
stats-HELP = ziponly
stats4-HELP = ziponly
utils-HELP = ziponly
stats4-SAVE = true

MASS-HELP = ziponly
boot-HELP = ziponly
cluster-HELP = ziponly
lattice-HELP = ziponly
mgcv-HELP = ziponly
nlme-HELP = ziponly
rpart-HELP = ziponly
survival-HELP = ziponly

pkg-%:
	@$(MAKE) --no-print-directory \
	  SAVE=$($*-SAVE) LAZY=$($*-LAZY) LAZYDATA=$($*-LAZYDATA) \
          DLLNM=$($*-DLLNM) FLIBS="$(FLIBS)" BUILD=$(BUILD) \
	  PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) RVER=$(RVER) \
	  -C $(PKGD)/$* -f $(RHOME)/src/gnuwin32/MakePkg
	@if test -d $(RLIB)/$*/data ; then \
	  $(MAKE) --no-print-directory $($*-ZIPDATA)data-$* ; \
	fi
ifeq ($(strip $(HELP)),YES)
	@$(ECHO) "  installing help"
  ifeq ($(strip $(DPKG)),)
    ifeq ($(strip $(WINHELP)),CHM)
	@$(MAKE) --no-print-directory -C ./help -s RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) DPKG=$(RLIB)/$* CHM=-chm $($*-HELP)help-$*
	@$(MAKE) --no-print-directory -C ./help -s RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) DPKG=$(RLIB)/$* CHM=-chm chm-$*
    else
	@$(MAKE) --no-print-directory -C ./help -s RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) DPKG=$(RLIB)/$* $($*-HELP)help-$*
    endif
  else
    ifeq ($(strip $(WINHELP)),CHM)
	@$(MAKE) --no-print-directory -C ./help -s RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) DPKG=$(DPKG) CHM=-chm $($*-HELP)help-$*
	@$(MAKE) --no-print-directory -C ./help -s RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) DPKG=$(DPKG) CHM=-chm  chm-$*
    else
	@$(MAKE) --no-print-directory -C ./help -s RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) DPKG=$(DPKG) $($*-HELP)help-$*
    endif
  endif
endif

pkgfake-%:
	@$(MAKE) --no-print-directory DLLNM=$($*-DLLNM)  FLIBS="$(FLIBS)" BUILD=$(BUILD) \
	  -C $(PKGD)/$* PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) RVER=$(RVER) \
	  -f $(RHOME)/src/gnuwin32/MakePkg fake
	@$(ECHO) "  installing help"
	@$(MAKE) --no-print-directory -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) DPKG=$(DPKG) pkgfake-$*


pkgclean-%:
	$(MAKE) --no-print-directory DLLNM=$($*-DLLNM) RHOME=$(RHOME) BUILD=$(BUILD) \
	  -C $(PKGD)/$* PKG=$* -f $(RHOME)/src/gnuwin32/MakePkg clean

pkgcheck-%:
	@$(ECHO) -------- Testing package $* --------
	-@$(MKDIR) -p $(PKGD)/$*/check
	@$(MAKE) --no-print-directory -C $(PKGD)/$*/check PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	  -f $(RHOME)/src/gnuwin32/check/PkgCheck
	@if test -d $(PKGD)/$*/tests ; then \
	  $(MAKE) --no-print-directory -C $(PKGD)/$*/tests PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	    -f $(RHOME)/src/gnuwin32/check/PkgCheck tests;\
	fi

lazyload-%:
	@$(MAKE) --no-print-directory PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) BUILD=$(BUILD) -C $(PKGD)/$* SPKG=$(PKGD)/$* -f $(RHOME)/src/gnuwin32/MakePkg lazyload

lazydata-%:
	@$(MAKE) --no-print-directory PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) BUILD=$(BUILD) -f $(RHOME)/src/gnuwin32/MakePkg lazydata

ziphelp-%:
	$(MAKE) --no-print-directory -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) DPKG=$(DPKG) ziphelp-$*

ziponly-%:

=== src/gnuwin32/bitmap/Makefile ===
include ../MkRules

JPEGDIR=jpeg-6b
PNGDIR=libpng

all:
	@$(MAKE) --no-print-directory buildzlib buildpng buildjpeg rbitmap.o 
	@$(MAKE) --no-print-directory installdll

buildzlib:
	@$(MAKE) -C ../../extra/zlib -f Makefile.win

buildpng:
	@$(MAKE) CC='$(CC)' RANLIB=$(RANLIB) ZLIBLIB=../../../extra/zlib ZLIBINC=../../../extra/zlib -C $(PNGDIR) -f scripts/makefile.std libpng.a

# jconfig.h and Makefile obtained running 'CC="gcc -mno-cygwin" ./configure'
# under CYGWIN. They are here since the configure script doesn't run 
# (I suspect) using the reduced set of tools we distribute.
buildjpeg: $(JPEGDIR)/jconfig.h Makefile.jpeg
	$(MAKE) CC='$(CC)' AR='$(AR) rc' RANLIB=$(RANLIB) -C $(JPEGDIR) -f ../Makefile.jpeg libjpeg.a

$(JPEGDIR)/jconfig.h: jconfig.h 
	$(CP) jconfig.h $(JPEGDIR)/jconfig.h

rbitmap-CFLAGS=-Wall -pedantic -DHAVE_PNG -DHAVE_JPEG -I../../extra/zlib -I./libpng -I$(JPEGDIR) -I../../include
Rbitmap-DLLLIBS=-L../ $(LIBUNICOWS) -lR
Rbitmap-DLLFLAGS=-s

Rbitmap.dll: rbitmap.o $(PNGDIR)/libpng.a $(JPEGDIR)/libjpeg.a

installdll: Rbitmap.dll
	$(CP) Rbitmap.dll ../../../bin

clean:
	$(RM) *.o *.a *.dll *.def *~ \#*\#
	-$(MAKE) CC='$(CC)' -C $(PNGDIR) -f scripts/makefile.std clean
	-$(MAKE) CC='$(CC)' -C $(JPEGDIR) -f ../Makefile.jpeg clean

=== src/gnuwin32/fixed/Makefile ===
include ../MkRules

R_HOME = ../../..

all: profiles fixhtml fixbin fixetc fixshare ../XINSTALL svnonly

profiles: $(R_HOME)/library/base/R/Rprofile

$(R_HOME)/library/base/R/Rprofile:  ../../library/profile/Common.R \
../../library/profile/Rprofile.windows
	@$(ECHO) -------- Building $@ from $^--------
	mkdir -p $(R_HOME)/library/base/R
	@$(CAT)  $^ > $@

fixbin:  cp2bin
	@$(ECHO) done > fixbin

cp2bin: $(wildcard ./bin/*)
ifeq ($(strip $(BUILD)),CROSS)
	@zip -ql bins $^
	@unzip -oq bins -d  $(R_HOME)
else
	@zip -q bins $^
	@unzip -oaq bins -d  $(R_HOME)
endif
	@$(RM) bins.zip

fixhtml:  html/rwin.html $(R_HOME)/doc/html/search/SearchEngine.html
	$(CP) -p html/rwin.html $(R_HOME)/doc/html
	$(CP) -p html/rwin.html $(R_HOME)/doc/html/index.html
	@$(ECHO) done > fixhtml

fixetc: $(wildcard ./etc/*)
	$(CP) -p $^ $(R_HOME)/etc
	@$(ECHO) done > fixetc

fixshare: share/tests.mk
	$(MKDIR) -p $(R_HOME)/share/make
	$(CP) -p $^ $(R_HOME)/share/make/wintests.mk
	@$(ECHO) done > fixshare	

svnonly:
	@$(MAKE) -C ../../../doc/manual -f Makefile.win svnonly

clean:
	$(RM) *~ */*~ fixhtml fixbin fixetc fixshare

distclean:

$(R_HOME)/doc/html/search/SearchEngine.html: $(R_HOME)/doc/html/search/SearchEngine-head.html $(R_HOME)/doc/html/search/SearchEngine-foot.html $(R_HOME)/doc/KEYWORDS.db
	(cd $(R_HOME)/doc; \
	cat html/search/SearchEngine-head.html > html/search/SearchEngine.html; \
	perl ../tools/keywords2html.pl KEYWORDS.db >> html/search/SearchEngine.html; \
	cat html/search/SearchEngine-foot.html >> html/search/SearchEngine.html)
../XINSTALL: bin/INSTALL
ifeq ($(strip $(BUILD)),CROSS)
	@$(SED) -e 's/"MINGW"/"CROSS"/' $< > $@
endif

=== src/gnuwin32/front-ends/Makefile ===
include ../MkRules
R_HOME = ../../..

ifdef DEBUG
  OPTFLAGS=-g
  LINKFLAGS=
  DLLFLAGS=
else
  OPTFLAGS=-O2 -Wall -pedantic
  LINKFLAGS=-s
  DLLFLAGS=-s
endif
CFLAGS=$(OPTFLAGS) -I../../include

all: $(R_HOME)/bin/Rgui.exe $(R_HOME)/bin/Rterm.exe \
     $(R_HOME)/bin/Rcmd.exe  $(R_HOME)/bin/RSetReg.exe  \
     $(R_HOME)/bin/Rproxy.dll $(R_HOME)/bin/R.exe \
     $(R_HOME)/bin/md5check.exe

$(R_HOME)/bin/Rgui.exe: Rgui.exe
	$(MKDIR) -p $(R_HOME)/bin
	$(CP) $^ $@

$(R_HOME)/bin/Rterm.exe: Rterm.exe
	$(MKDIR) -p $(R_HOME)/bin
	$(CP) $^ $@	

$(R_HOME)/bin/Rcmd.exe: Rcmd.exe
	$(MKDIR) -p $(R_HOME)/bin
	$(CP) $^ $@

$(R_HOME)/bin/RSetReg.exe: RSetReg.exe
	$(MKDIR) -p $(R_HOME)/bin
	$(CP) $^ $@

$(R_HOME)/bin/R.exe: R.exe
	$(MKDIR) -p $(R_HOME)/bin
	$(CP) $^ $@	

$(R_HOME)/bin/md5check.exe: md5check.exe
	$(MKDIR) -p $(R_HOME)/bin
	$(CP) $^ $@	

graphappmain.o: ../graphapp/graphappmain.c
	$(CC) -c -o $@ -I../graphapp $(CFLAGS) $^

rgui-CFLAGS=-DWin32
rterm-CFLAGS=-DWin32
Rgui-LINKFLAGS=-mwindows

Rterm-LIBS=$(LIBUNICOWS) -luser32 -L.. -lR
Rgui-LIBS=-L.. $(LIBUNICOWS) -lR
Rpwd-LIBS=$(LIBUNICOWS) -lkernel32

Rgui.exe: graphappmain.o  rgui.o rgico.o

Rterm.exe: graphappmain.o rterm.o rtico.o

Rcmd.exe: rcmd.o ../rhome.o ../shext.o rcico.o rcmdfn.o

R.exe: R.o ../rhome.o ../shext.o rcico.o rcmdfn.o

RSetReg.exe: RSetReg.o ../rhome.o rcico.o

md5check-CFLAGS=-I../../../include -I../../library/tools/src
md5check.exe : md5check.o md5ico.o ../../library/tools/src/md5.o

Rpwd:
	$(MAKE) -C ../../include -f Makefile.win version
	$(MAKE) Rpwd.exe

Rpwd.exe: rpwd.o rcico.o

rcmd.o R.o rgui.o rterm.o RSetReg.o rproxy_impl.o rgico.o rtico.o rcico.o: ../../include/Rversion.h

clean:
	$(RM) *.o *.obj *.exe *~ *.exp *.def *.dll *.lib

bdx-CFLAGS=-I../../include
rproxy-DLLFLAGS=-mwindows
rproxy-DLLLIBS=-L.. $(LIBUNICOWS) -lR
rproxy.dll: rproxy.o rproxy_dev.o rproxy_impl.o bdx.o rtico.o

$(R_HOME)/bin/Rproxy.dll: rproxy.dll
	$(MKDIR) -p $(R_HOME)/bin
	$(CP) $^ $@

=== src/gnuwin32/getline/Makefile ===
include ../MkRules

CFLAGS=-DWin32
LINKFLAGS=-s

ifdef DEBUG
 CFLAGS+=-g
endif

gl.a: getline.o

test: testgl.exe
	$(ECHO) starting testgl. Hit CRTL+BREAK to stop it.
	testgl.exe

testgl.exe: testgl.o getline.o	


clean:
	$(RM) *.o *~ *.exe *.exp gl.a

=== src/gnuwin32/graphapp/Makefile ===
include ../MkRules

all: makeMakedeps ga.a

ifdef DEBUG
  DEBUGFLAG=-g
else
  DEBUGFLAG=
endif

CFLAGS=-I. -I.. -I../../include -Wall $(DEBUGFLAG)  -O2 -DINDLL -DR_DLL_BUILD
SOURCES=$(filter-out graphappmain.c, $(wildcard *.c))
OBJS=$(foreach i, $(SOURCES), $(basename $i).o)

ga.a: $(OBJS)

clean:
	$(RM) *.o *.a *~ \#*\# *.d Makedeps

# Dependencies
DEPS=$(SOURCES:.c=.d)

makeMakedeps: $(DEPS)
	@$(RM) Makedeps
	@cat $(DEPS) >> Makedeps

-include Makedeps

=== src/gnuwin32/installer/Makefile ===
# Makefile for R for Windows Installers

include ../MkRules
R_HOME = ../../..
include $(R_HOME)/share/make/vars.mk

## use next to install other packages from main library
EXTRA_PKGS =

FULLVERSION=`cat ../../../VERSION`
RPREFIX = $(shell perl ../fixed/rwver.pl $(R_HOME)/VERSION)
LIBFILES = $(foreach i, $(R_PKGS_BASE) $(R_PKGS_RECOMMENDED) $(EXTRA_PKGS), $(R_HOME)/library/$i) $(R_HOME)/library/R.css

INFO_FILES = AUTHORS COPYING COPYING.LIB FAQ NEWS ONEWS README RESOURCES \
	THANKS Y2K
GW_INFO_FILES = CHANGES CHANGES1 COPYRIGHTS README.Rterm rw-FAQ

ETC_FILES = Rprofile Rconsole Rdevga rgb.txt repositories

GW32_FILES = R.exp Rblas.def MkRules MakePkg MakeDll \
	  Rpwd.exe pwd.pl makeDllRes.pl install-save.sh man-install.sh

# we don't want share/{Makefile.in,sh} installed
SHARE_DIRS = R licenses locale make perl texmf

all: $(RPREFIX).exe # miniR.exe

imagedir:
	$(RM) -r $(RPREFIX)
	$(MKDIR) $(RPREFIX)
	$(CP) -pr $(R_HOME)/bin $(R_HOME)/modules $(RPREFIX)
ifneq ($(strip $(BUILD)),CROSS)
	mv $(RPREFIX)/bin/R.dll $(RPREFIX)/bin/Rmbcs.dll 
	mv $(RPREFIX)/bin/Rnombcs.dll $(RPREFIX)/bin/R.dll
endif
# copy base and recommended packages
	$(MKDIR) -p $(RPREFIX)/library
	$(CP) -pr $(LIBFILES) $(RPREFIX)/library
	$(RM) $(RPREFIX)/library/*/MD5
# morley.tab is needed for R-intro Appendix A, but is now installed
#	$(CP) -p $(R_HOME)/src/library/datasets/data/morley.tab $(RPREFIX)/library/datasets/data
	$(RM) $(RPREFIX)/*/Makefile.in
	$(MKDIR) -p $(RPREFIX)/etc
	$(CP) -p $(foreach i,$(ETC_FILES),$(R_HOME)/etc/$i) $(RPREFIX)/etc
# copy info and documentation files
	$(MKDIR) -p $(RPREFIX)/doc
	$(CP) -p $(R_HOME)/doc/CRAN_mirrors.csv $(RPREFIX)/doc
	$(MKDIR) -p $(RPREFIX)/doc/manual
	$(CP) -pr $(R_HOME)/doc/html $(RPREFIX)/doc
	$(CP) -p $(R_HOME)/doc/manual/*.html $(R_HOME)/doc/manual/*.pdf \
	  $(RPREFIX)/doc/manual
#	html copies of these are in doc/manual, and we don't have PDFs on menus
	$(RM) $(RPREFIX)/doc/manual/R-FAQ.pdf
	$(RM) $(RPREFIX)/doc/html/R-admin.html 
	$(RM) $(RPREFIX)/doc/html/index.html $(RM) $(RPREFIX)/doc/html/index-default.html
#
	$(CP) -p $(foreach i,$(INFO_FILES),$(R_HOME)/$i) $(RPREFIX)
	$(CP) -p $(foreach i,$(GW_INFO_FILES),../$i) $(RPREFIX)
	$(SED) -e s/@RWVER@/$(RPREFIX)/g \
	  -e s/@RVER@/$(RVER)/g \
	  -e "s/@FULLVERSION@/$(FULLVERSION)/g" ../README > $(RPREFIX)/README.$(RPREFIX)
	$(SED) -e 3,5d ../README.packages > $(RPREFIX)/README.packages
# convert docs and batch files to CRLF: might already be on Windows, though.
ifeq ($(strip $(BUILD)),CROSS)
	zip -l dosfiles.zip $(RPREFIX)/* $(RPREFIX)/bin/*.bat
	unzip -o dosfiles.zip
else
	zip dosfiles.zip $(RPREFIX)/* $(RPREFIX)/bin/*.bat
	unzip -ao dosfiles.zip
endif
	$(RM) dosfiles.zip
#
# files to make source packages
	$(MKDIR) -p $(RPREFIX)/share \
	  $(RPREFIX)/src/library $(RPREFIX)/src/gnuwin32/fixed
	$(CP) $(R_HOME)/doc/html/logo.jpg $(RPREFIX)/doc/html
	$(CP) $(R_HOME)/doc/KEYWORDS* $(RPREFIX)/doc
	$(CP) -p $(foreach i,$(GW32_FILES),../$i) $(RPREFIX)/src/gnuwin32
	$(SED) -e s/@RVER@/$(RVER)/g ../Makefile.packages > $(RPREFIX)/src/gnuwin32/Makefile
	$(CP) ../fixed/dobundle.pl $(RPREFIX)/src/gnuwin32/fixed
	$(CP) -pr ../help ../check $(RPREFIX)/src/gnuwin32
	$(RM) $(RPREFIX)/src/gnuwin32/help/*.c \
	  $(RPREFIX)/src/gnuwin32/help/MkChmDll
	(cd ..; $(MAKE) --no-print-directory -C installer/$(RPREFIX)/src/gnuwin32/help clean)
	$(CP) -pr $(R_HOME)/include $(R_HOME)/lib $(RPREFIX)
	$(CP) -pr $(foreach i,$(SHARE_DIRS),$(R_HOME)/share/$i) $(RPREFIX)/share
	(cd ..; $(MAKE) --no-print-directory PKGDIR=. pkgclean-windlgs)
	$(CP) -pr ../windlgs $(RPREFIX)/src/library
#
	find $(RPREFIX) -name .svn -prune -exec rm -rf \{\} \;

md5sums:
	@echo "adding MD5 checksums"
	@(cd $(RPREFIX); echo "tools:::.installMD5sums(\".\")" | \
	  R_DEFAULT_PACKAGES=NULL LC_COLLATE=C R_OSTYPE=windows \
	  ../../../../bin/Rterm.exe --vanilla --slave)

fixups:
	$(CAT) $(RPREFIX)/library/*/CONTENTS >  \
	  $(RPREFIX)/doc/html/search/index.txt
	echo "make.packages.html(.Library)" | $(RPREFIX)/bin/rterm --vanilla --slave LC_COLLATE=C
	$(CP) -pr $(R_HOME)/Tcl $(RPREFIX)

R.iss Rsmall.iss: JRins.pl imagedir fixups md5sums
	perl JRins.pl $(RPREFIX) $(RPREFIX)

$(RPREFIX).exe: R.iss
	"$(ISDIR)/iscc" R.iss > $(RPREFIX).log
miniR.exe: Rsmall.iss
	"$(ISDIR)/iscc" Rsmall.iss > miniR.log

clean:
	rm -rf R.iss Rsmall.iss *.log $(RPREFIX) 

distclean: clean
	rm -f $(RPREFIX).exe miniR*

myR:
	$(CAT) $(IMAGEDIR)/library/*/CONTENTS >  \
	  $(IMAGEDIR)/doc/html/search/index.txt
	echo "make.packages.html(.Library)" | $(IMAGEDIR)/bin/rterm --vanilla --slave LC_COLLATE=C
	@echo "adding MD5 checksums"
	@(cd $(IMAGEDIR); echo "tools:::.installMD5sums(\".\")" | \
	  R_DEFAULT_PACKAGES=NULL LC_COLLATE=C R_OSTYPE=windows \
	  bin/Rterm.exe --vanilla --slave)
	perl JRins.pl $(RPREFIX) $(IMAGEDIR)
	"$(ISDIR)/iscc" R.iss > myR.log

=== debian/changelog ===
r-base (2.0.1.beta.20050410-1) unstable; urgency=low

  * Upgraded to the R 2.1.0 beta release candidate dated 2005-04-10

  * With R 2.1.0 scheduled to be released on April 18, this release
    candidate will be uploaded to unstable to allow for wider testing
  
  * debian/rules: Also copy new file 'repositories' to /etc/R and link back

 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 10 Apr 2005 21:12:25 -0500

r-base (2.0.1.alpha.20050403-1) experimental; urgency=low

  * Upgraded to the R 2.1.0 alpha release candidate dated 2005-04-03

  * This upload is still slated for experimental; beta release 
    candidates of 2.1.0 will go into unstable

 -- Dirk Eddelbuettel <edd@debian.org>  Sun,  3 Apr 2005 16:04:29 -0500

r-base (2.0.1.alpha.20050322-1) experimental; urgency=low

  * Initial attempt at packaging the upcoming R 2.1.0

  * debian/rules: No longer install $RHOME/bin/Rdindex
  
  * debian/rules: No longer build the Gnome GUI which has been
    unbundled upstream as it was never fully completed
  * debian/control: Update r-gnome Description
  * debian/control: r-gnome is now Binary: all, removed ${shlibs:Depends}
    and versioned (= ${Source-Version}) part of Depends on r-base-core 
  * debian/control: Reduce Build-Depends by libgnome-dev, libzvt-dev, 
    libgtkxmhtml-dev, libglade-gnome0-dev
  * debian/r-gnome.NEWS: New file with message about removeal of UI
  
  * debian/control: For r-base-dev, switched from the black magic
    "g77 | m68k, f2c | not+m68k, type-handling" to "g77, f2c" as
    type-handling no longer allows this (Closes: #296287)

  * debian/r-mathlib.shlibs: Correct to 'libRmath 1 r-mathlib (>= 2.0)'
    with thanks to Chris Lawrence

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 21 Mar 2005 21:20:09 -0600

r-base (2.0.1-4) unstable; urgency=low

  * Removed erroneously left-over doc-base file (Closes: #296194)
  * debian/r-doc-{html,pdf}.links: Link individual files, not the
    entire manual directory, in order to circumvent a dhelp bug 

 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 20 Feb 2005 17:24:07 -0600

r-base (2.0.1-3) unstable; urgency=low

  * debian/r-doc-html.doc-base.*: Added five doc-base control files
    to register the html documentation with doc-base (Closes: #296089)

 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 20 Feb 2005 07:59:53 -0600

r-base (2.0.1-2) unstable; urgency=low

  * debian/control: Switch the Depends: on the helper package r-base-dev
    to libreadline5-dev to help readline5 migration (Closes: #291655)
  * debian/control: Also switch Build-Depends: to libreadline5-dev
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 23 Jan 2005 13:39:50 -0600

r-base (2.0.1-1) unstable; urgency=medium

  * New upstream release
  * Urgency medium as this version contains numerous upstream fixes, 
    as well as Debian fixes from 2.0.0-4 that have are not yet in testing 

  * debian/control: Add r-recommended to Depends: for r-base

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 15 Nov 2004 09:39:01 -0600

r-base (2.0.0-4) unstable; urgency=medium

  * Urgency medium to get the fix into the testing distribution in which 
    r-recommended currently has insufficiently detailed Depends:
  * debian/control: Change Depends: for r-recommended to be versioned, and
    impose a minimum standard of package versions rebuilt under R 2.0.0 
    as required by the underlying lazyloading changes (Closes: #278528)
  
 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 27 Oct 2004 20:26:31 -0500

r-base (2.0.0-3) unstable; urgency=low
  
  * Two improvements suggested by Kurt Hornik:
    - debian/control: r-base now Depends: on r-base-core (= ${Source-Version})
    - debian/control: Fix MASS book title in Description: of r-recommends

  * Reorganisation of r-mathlib suggested and tested by Faheem Mitha:
    - debian/control: r-mathlib now only Recommends: insteads of Depends:
      on r-base-core and r-base-dev (Closes: #276038)
    - debian/rules: Small changes to give r-mathlib its own doc directory
    - debian/r-mathlib.links: Renamed to r-mathlib.links.unused disable
  
  * Update to use of Lapack code as suggested by Doug Bates:
    - debian/rules: Set Lapack back to --with-lapack=no
    - debian/control: Remove "lapack3-dev | atlas3-base-dev" from Build-Depends
    - debian/control: Remove "lapack3-dev | atlas3-base-dev | liblapack-3.so"
      from Depends for r-base-dev as well
    - debian/rules: Turn 'make check' back on (outside of arm)
  
 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 13 Oct 2004 20:12:30 -0500

r-base (2.0.0-2) unstable; urgency=low

  * src/main/startup.c: Removed 'static' on RestoreAction declaration
    as recommend by Brian Ripley in bug report follow-up (Closes: #275791)

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 11 Oct 2004 09:55:11 -0500

r-base (2.0.0-1) unstable; urgency=low

  * New upstream release
  
  * src/library/tools/R/admin.R, src/scripts/INSTALL.in: Applied
    small patch by Brian Ripley to address package build issues

 -- Dirk Eddelbuettel <edd@debian.org>  Tue,  5 Oct 2004 17:53:51 -0500

r-base (1.9.1.beta.20040929-1) experimental; urgency=low

  * Upgraded to the R 2.0.0 beta release candidate dated 2004-09-29
  * Still uploading to 'experimental' to keep 1.9.1-3 in testing

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 29 Sep 2004 15:40:10 -0500

r-base (1.9.1.beta.20040928-1) experimental; urgency=low

  * Upgraded to the R 2.0.0 beta release candidate dated 2004-09-28
  * Still uploading to 'experimental' to keep 1.9.1-3 in testing
  * debian/rules: No longer install BUGS which is no longer in upstream sources

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 28 Sep 2004 22:22:52 -0500

r-base (1.9.1.beta.20040925-1) experimental; urgency=low

  * Upgraded to the R 2.0.0 beta release candidate dated 2004-09-25
  * Still uploading to 'experimental' to keep 1.9.1-3 in testing

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 25 Sep 2004 08:43:01 -0500

r-base (1.9.1.beta.20040921-1) experimental; urgency=low



=== debian/control ===
Source: r-base
Section: math
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Uploaders: Douglas Bates <bates@stat.wisc.edu>
Standards-Version: 3.6.1.1
Build-Depends: refblas3-dev | atlas3-base-dev, tcl8.4-dev, tk8.4-dev, bison, g77 [!m68k], f2c [m68k], groff-base, libncurses5-dev, libreadline5-dev, debhelper (>= 3.0.0), texi2html, texinfo (>= 4.1-2), libbz2-dev, libpcre3-dev, libpaperg-dev, tetex-bin, tetex-extra, xpdf-reader, libpaper-utils, zlib1g-dev, libpng12-dev, libjpeg62-dev

Package: r-base
Architecture: all
Depends: r-base-core (= ${Source-Version}), r-recommended (= ${Source-Version})
Recommends: r-base-html, r-base-latex
Suggests: libpaperg, ess, r-doc-info | r-doc-pdf | r-doc-html, libpaper-utils
Description: GNU R statistical computing language and environment
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.
 .
 This packages is a meta-package which eases the transition from the 
 pre-1.5.0 package setup with its larger r-base package. Once installed, it 
 can be safely removed and apt-get will automatically upgrade its components
 during future upgrades.  Providing this packages gives a way to users to 
 then only install r-base-core (but not, say, r-base-latex) if they so desire.

Package: r-base-core
Architecture: any
Depends: ${perl:Depends}, zlib-bin, ${shlibs:Depends}
Replaces: r-base (<= 1.4.1-1), r-recommended (<< 1.9.0)
Recommends: r-recommended, r-base-dev
Suggests: libpaperg, ess, r-doc-info | r-doc-pdf | r-doc-html, r-mathlib, r-base-html | r-base-latex
Description: GNU R core of statistical computing language and environment
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.
 .
 This package provides the core GNU R system from which only the optional
 documentation packages r-base-html, r-base-latex, r-doc-html, r-doc-pdf 
 and r-doc-info have been split off to somewhat reduce the size of this 
 package. 

Package: r-gnome
Section: gnome
Architecture: all
Depends: r-base-core 
Recommends: r-cran-gtkdevice
Description: GNU R Gnome gui for statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This package used to provides the dynamic link libraries needed to start 
 GNU R with the GNOME libraries frontend as in "R --gui=GNOME".
 .
 As of R 2.1.0, this interface is no longer provided with the upstream
 sources. As such, this package is now an empty stub that will be removed
 in a subsequent revision of the Debian package.

Package: r-base-dev
Architecture: all
Section: devel
Depends: r-base-core (= ${Source-Version}), refblas3-dev | atlas3-base-dev | libblas-3.so, build-essential, g77, f2c, gcc, g++, libncurses5-dev, libreadline5-dev, libjpeg62-dev, libpcre3-dev, libpng12-dev, zlib1g-dev, libbz2-dev
Description: GNU R installation of auxiliary GNU R packages 
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages ensures that other Debian packages needed for installation of
 some auxiliary R packages are installed.

Package: r-mathlib
Architecture: any
Depends: 
Recommends: r-base-core (= ${Source-Version}), r-base-dev (= ${Source-Version})
Description: GNU R standalone mathematics library
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the libRmath shared and static libraries which can
 be called from standalone C or C++ code.

Package: r-base-html
Architecture: all
Priority: extra
Depends: r-base-core
Replaces: r-base (<= 1.4.1-1), r-recommended (<< 1.9.0)
Suggests: r-doc-html, mozilla | www-browser
Description: GNU R html docs for statistical computing system functions
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides html documentation suitable for browsing with a 
 web-browser for the libraries included in the r-base package. It is not 
 a required package as the same documentation is already included for 
 on-line browsing. 

Package: r-base-latex
Architecture: all
Priority: extra
Depends: r-base-core
Replaces: r-base (<= 1.4.1-1), r-recommended (<< 1.9.0)
Description: GNU R LaTeX docs for statistical computing system functions
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides latex documentation suitable for off-line printing
 for the libraries included in the r-base package. It is not a required 
 package as the same documentation is already included for on-line browsing.

Package: r-doc-pdf
Architecture: all
Section: doc
Suggests: r-base-core, xpdf-reader | pdf-viewer
Description: GNU R pdf manuals for statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the R manuals in pdf format. The sibling packages
 r-doc-html and r-doc-info provides the same manuals.

Package: r-doc-html
Architecture: all
Section: doc
Suggests: r-base-core, mozilla | www-browser
Replaces: r-base (<= 1.4.1-1)
Description: GNU R html manuals for statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the R manuals in html format. The sibling packages
 r-doc-pdf and r-doc-info provides the same manuals.

Package: r-doc-info
Architecture: all
Section: doc
Replaces: r-base (<= 1.4.1-1)
Suggests: r-base-core, info (>= 3.12) | info-browser
Description: GNU R info manuals statistical computing system
 R is `GNU S' - A language and environment for statistical computing
 and graphics. R is similar to the award-winning S system, which was
 developed at Bell Laboratories by John Chambers et al. It provides a
 wide variety of statistical and graphical techniques (linear and
 nonlinear modelling, statistical tests, time series analysis,
 classification, clustering, ...).
 .
 R is designed as a true computer language with control-flow
 constructions for iteration and alternation, and it allows users to
 add additional functionality by defining new functions. For
 computationally intensive tasks, C, C++ and Fortran code can be
 linked and called at run time.
 .
 This packages provides the R manuals in info format. The sibling packages
 r-doc-html and r-doc-pdf provide the same manuals.

Package: r-recommended
Architecture: all

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for the Debian GNU/Linux r-base package
# Copyright 1997-2004 by Douglas Bates <bates@stat.wisc.edu> 
#		     and Dirk Eddelbuettel <edd@debian.org>

# $Id: rules,v 1.56 2004/04/09 13:32:46 bates Exp $

corepackage	= r-base-core
latexpackage	= r-base-latex
pdfpackage	= r-doc-pdf
htmlpackage	= r-doc-html
gnomepackage	= r-gnome
nmathpackage	= r-mathlib
infopackage	= r-doc-info
recdpackage	= r-recommended

# for the standalone library, no sonames are assigned in the upstream Makefiles
somaj		= 1
somin		= 0
sorel		= 0
libver		= $(somaj).$(somin).$(sorel)

debbase		:= $(CURDIR)/debian
debtmp		:= $(debbase)/tmp
debdoc		:= $(debbase)/$(corepackage)/usr/share/doc/$(corepackage)
debmat		:= $(debbase)/$(nmathpackage)
debetc		:= $(debbase)/$(corepackage)/usr/lib/R/etc
debinf		:= $(debbase)/$(infopackage)

arch		:= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# set this to 1 (default) if you want the Gnome GUI package
# edd 27 Feb 2005  as of R 2.1.0, the Gnome GUI is no longer included
gnome		= 0
ifeq ($(gnome),0)
gnomeconfig	= --without-gnome
else
gnomeconfig	= --with-gnome
endif


#export DH_VERBOSE = 1
export DH_COMPAT  = 3

# edd 15 Aug 2001  default to blas, atlas can override it 
#atlas		= --with-blas=blas
# dmb 04 Apr 2003  better to use no specify blas
# atlas			= --with-blas
# edd 28 Apr 2003  try configuring with atlas
# atlas		= --with-blas=atlas
# edd 16 Oct 2003  back to older default
#atlas		= --with-blas=blas
# edd 26 Feb 2004  point to refblas3 
atlas		= --with-blas=-lblas-3

# edd 08 Mar 2003  use the new lapack feature
# edd 27 Apr 2003  Set this to =no as we currently see numerical errors
#lapack		= --with-lapack=no
# edd 26 Feb 2004  point to lapack3 
#lapack		= --with-lapack=-llapack-3
# edd 13 Oct 2004  Set this once again to =no as we still see numerical errors
lapack		= --with-lapack=no

# edd 02 Sep 2001  default to g77 but let m68k use f2c
# edd 06 Mar 2003  enforce 3.2 versions explicitly 
#		   so that on testing we will pick them over 2.95
# edd 07 Jun 2003  let's fall back to the default compilers
fortrancompiler	= F77=g77
compiler	= gcc
cxxcompiler	= g++
compilerflags	= -O2

# edd 04 Sep 2001  default compiler flags, lowered for m68k
compilerflags	= -O2
# m68k barks when using g77, and when gcc use -O2
# edd 26 Nov 2002  switched back to g77
# edd 02 Jun 2003  switched back
# cts 04 Jun 2003  use -O1 on m68k
ifeq ($(arch),m68k-linux)
fortrancompiler	= F2C=f2c
compilerflags	= -O1
endif

# edd 14 Nov 2003  turn blas off on arm
ifeq ($(arch),arm-linux)
atlas		= --without-blas
endif

## edd 09 Nov 2001  ia64 needs gcc-3.0, hppa gets it by default
#ifeq ($(arch),ia64-linux)
#fortrancompiler = F77=g77-3.0
#compiler	= gcc-3.0
#cxxcompiler	= g++-3.0
#compilerflags	= -O2
#endif

## lamont@debian.org 06 Dec 2001  hppa needs -ffunction-sections  
ifeq ($(arch),hppa-linux)
compilerflags	= -O2 -ffunction-sections
endif

## edd 20 Jun 2002	no optimisation or debugging on baby systems
## edd 02 Jun 2003	use this on arm only 
##ifneq "$(findstring $(arch), m68k-linux arm-linux)" ""
ifneq "$(findstring $(arch), arm-linux)" ""
compilerflags	= -O0 -g0
endif

get-orig-source: upstream
upstream:
        #links http://cran.us.r-project.org/src/base
	links http://cran.r-project.org/src/base/?M=D

upstreamdevel:
	links ftp://ftp.stat.math.ethz.ch/Software/R
        #links http://cran.us.r-project.org/src/base
        #rsync -vaC rsync.r-project.org::r-devel .

upstreamprerelease:
	links http://cran.r-project.org/src/base-prerelease


## edd 24 Oct 2003  build is invoked by the buildd, so we would prefer to
##		    not imply build-indep; unfortunately R does not build
##		    properly without it, so we have to stick with it
## edd 15 Jan 2004  trying again on build only build: build-arch build-indep
##		    the main hook is to then have binary depend on both
##		    binary-arch and binary-indep, and those on their builds
build: build-arch 

build-arch: make-arch 

build-indep: make-indep 

configure: configure-stamp
configure-stamp:	
	@echo "*** configure ***"

        # we have to disable use of the expanded R_LD_LIBRARY_PATH as it
        # conflicts with Debian's Atlas-can-replace-Blas scheme
        # so set R_LD_LIBRARY_PATH to the minimal value R_HOME/bin
        # and discard what configure finds for it on this machine
	perl -p -i -e 's|:\@R_LD_LIBRARY_PATH\@||' src/scripts/R.sh.in

	dh_testdir
	R_PAPERSIZE=letter				\
	R_BROWSER=sensible-browser			\
	PAGER=/usr/bin/pager				\
	PERL=/usr/bin/perl				\
	R_UNZIPCMD=/usr/bin/miniunzip			\
	R_ZIPCMD=/usr/bin/minizip			\
	R_PRINTCMD=/usr/bin/lpr				\
	CC=${compiler}						\
	CXX=${cxxcompiler}						\
	${fortrancompiler}						\
	CPPFLAGS=					\
	LDFLAGS=					\
	FLIBS=						\
	./configure --prefix=/usr			\
		    --with-bzlib			\
		    --with-jpeg				\
		    --with-pcre				\
		    --with-png				\
		    --with-readline			\
		    --with-tcltk			\
		    --with-zlib				\
		    --mandir=/usr/share/man		\
		    --infodir=/usr/share/info		\
		    $(atlas)		\
		    $(lapack)		\
		    $(gnomeconfig)			\
		    --enable-R-profiling		\
		    --enable-R-shlib			\
		    --without-recommended-packages	\
		    --build $(arch)

	touch configure-stamp

make-arch: configure make-arch-stamp 
make-arch-stamp: 
	@echo "*** make-arch ***"
	$(MAKE)		CFLAGS="$(compilerflags)"		\
			CXXFLAGS="$(compilerflags)"		\
			FFLAGS="$(compilerflags)"		\
			CC=${compiler}				\
			CXX=${cxxcompiler}			\
			${fortrancompiler}			\
			R

        # the top-level 'make stamp-recommended' target implies 'make docs'
        # which (for the buildds) implies a lot of time wasted generating 
        # output we already take from the initial i386 build
#	$(MAKE)		CFLAGS="$(compilerflags)"		\
#			CXXFLAGS="$(compilerflags)"		\
#			FFLAGS="$(compilerflags)"		\
#			CC=${compiler}				\
#			CXX=${cxxcompiler}			\
#			${fortrancompiler}			\
#			stamp-recommended

        # make standalone math lib
	(cd src/nmath/standalone;				\
		$(MAKE)	CFLAGS="$(compilerflags) -D_REENTRANT"	\
			CXXFLAGS="$(compilerflags) -D_REENTRANT"\
			FFLAGS="$(compilerflags) -D_REENTRANT"	\
			CC=${compiler}				\
			CXX=${cxxcompiler}			\
			${fortrancompiler}			\
			libRmath_la_LDFLAGS=-Wl,-soname,libRmath.so.$(somaj) \
			)

        # edd 25 Jan 2004  make install needs html docs
        # edd 03 Feb 2004  new test, try without 
        #make docs
        # edd 15 Jan 2004  make install needs html docs
        # edd 25 Jan 2004  not needed as we have 'make docs'
        ## make html
	$(MAKE) docs R_CMD_BUILD_HELP_OPTS="--txt --example"

	touch make-arch-stamp

make-indep: configure make-indep-stamp
make-indep-stamp:
	@echo "*** make-indep ***"
        ## edd 12 Jan 2004 uncommenting 'make docs' to split binary all/any
        ##	  now that recommended packages aren't made
        ## edd 25 Jan 2004 make docs and make html are made in make-arch
        ## edd 05 Feb 2004 finally, this works in pre-1.9.0 with Kurt's
        ##		   R_CMD_BUILD_HELP_OPTS
	$(MAKE) docs
	$(MAKE) html
	$(MAKE) help
	$(MAKE) info
	$(MAKE) pdf
	touch make-indep-stamp

make: make-stamp
make-stamp: make-arch make-indep 

check: make-arch check-stamp
check-stamp: 
	@echo "*** check ***"
ifneq	($(arch),arm-linux)
	-make check
endif
	touch check-stamp

clean:
	@echo "*** clean ***"
	dh_testdir
	dh_testroot
	rm -f	configure-stamp \
		build-stamp build-indep-stamp build-arch-stamp \
		make-stamp make-arch-stamp make-indep-stamp \
		install-indep-stamp install-arch-stamp \
		check-stamp 
	-$(MAKE) distclean
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp debian/files* core debian/substvars
	-rm -f doc/html/function.html doc/html/packages.html
	-rm -f modules/*.so
        # left over in CVS from r-base --> r-base-core transition
	(cd debian; rm -vf r-base.dirs r-base.files r-base.lintian \
			r-base.menu r-base.postinst)	
	dh_clean

install: install-arch install-indep 

install-arch: make-arch check install-arch-stamp
install-arch-stamp: 
	@echo "*** install-arch ***"

=== debian/watch ===
# format version number, currently 2; this line is compulsory!
version=2

# This is one format for an HTTP site, which is the same as the FTP format
http://cran.r-project.org/src/base/R-2/R-([-0-9\.]*).tar.gz
